<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/Application.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/Application.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 9 november 2008, 11:48</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef APPLICATION_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define APPLICATION_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Object.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "Array.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "String.h"</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include "AppType.h"</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#include "../OS/GuessOS.h"</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#define thisapp ::Sylph::Application::self_app</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 SYLPH_BEGIN_NAMESPACE
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">class </span>ApplicationSelf;
<a name="l00038"></a>00038 <span class="keyword">class </span>File;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span>Array;
<a name="l00041"></a>00041 <span class="keyword">class </span>String;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 SYLPH_PUBLIC
<a name="l00044"></a>00044 
<a name="l00055"></a><a class="code" href="class_sylph_1_1_application.html">00055</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a> : <span class="keyword">public</span> <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00056"></a>00056     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_application_self.html" title="An Application representing the currently running application.">ApplicationSelf</a>;
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00069"></a><a class="code" href="class_sylph_1_1_application.html#86f3f28afa3682734789a12ae578c656">00069</a>     <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> <a class="code" href="class_sylph_1_1_application.html#86f3f28afa3682734789a12ae578c656" title="Returns the location of the file containing the object code of the application.">location</a>() {
<a name="l00070"></a>00070         <span class="keywordflow">return</span> _location;
<a name="l00071"></a>00071     }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     <span class="keyword">static</span> <a class="code" href="class_sylph_1_1_application_self.html" title="An Application representing the currently running application.">ApplicationSelf</a> * self_app;
<a name="l00074"></a>00074 
<a name="l00100"></a>00100     <span class="keyword">static</span> <span class="keywordtype">void</span> init(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[], <span class="keywordtype">char</span> * apple[], <a class="code" href="namespace_sylph.html#8e3a8cf0fd1c1cf417e7834d2a473dc4" title="This enumeration contains the possible Application Types.">AppType</a> type,
<a name="l00101"></a>00101             <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> name);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="keyword">protected</span>:
<a name="l00104"></a>00104     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> _location;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="keyword">private</span>:
<a name="l00107"></a>00107     <a class="code" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a>();
<a name="l00108"></a>00108     <span class="keyword">virtual</span> ~<a class="code" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 };
<a name="l00112"></a>00112 
<a name="l00120"></a><a class="code" href="class_sylph_1_1_application_self.html">00120</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_application_self.html" title="An Application representing the currently running application.">ApplicationSelf</a> : <span class="keyword">public</span> <a class="code" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a> {
<a name="l00121"></a>00121     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_application.html" title="Class representing an application.">Application</a>;
<a name="l00122"></a>00122 <span class="keyword">public</span>:
<a name="l00123"></a>00123     <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> appName() {
<a name="l00124"></a>00124         <span class="keywordflow">return</span> _appName;
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126 
<a name="l00133"></a>00133     <a class="code" href="namespace_sylph.html#8e3a8cf0fd1c1cf417e7834d2a473dc4" title="This enumeration contains the possible Application Types.">AppType</a> appType();
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     <span class="keywordtype">void</span> fail(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> reason);
<a name="l00136"></a>00136     <span class="keywordtype">void</span> fail(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> reason, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> file, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; bundle() = 0;
<a name="l00140"></a>00140     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; resourceDir() = 0;
<a name="l00141"></a>00141     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a> resource(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rsc) = 0;
<a name="l00142"></a>00142     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; libraryDir() = 0;
<a name="l00143"></a>00143     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; pluginDir() = 0;
<a name="l00144"></a>00144     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; plugindisabledDir() = 0;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; systemLibraryDir() = 0;
<a name="l00147"></a>00147     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; systemSettings() = 0;
<a name="l00148"></a>00148     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; systemSettingsDir() = 0;
<a name="l00149"></a>00149     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; systemPluginDir() = 0;
<a name="l00150"></a>00150     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; systemPluginDisabledDir() = 0;
<a name="l00151"></a>00151     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; systemResourceDir() = 0;
<a name="l00152"></a>00152     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a> systemResource(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rsc) = 0;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userHome() = 0;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userLibraryDir() = 0;
<a name="l00157"></a>00157     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userSettings() = 0;
<a name="l00158"></a>00158     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userSettingsDir() = 0;
<a name="l00159"></a>00159     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userPluginDir() = 0;
<a name="l00160"></a>00160     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userPluginDisabledDir() = 0;
<a name="l00161"></a>00161     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; userResourceDir() = 0;
<a name="l00162"></a>00162     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a> userResource(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rsc) = 0;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; prefix() = 0;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="keyword">protected</span>:
<a name="l00167"></a>00167     <a class="code" href="class_sylph_1_1_application_self.html" title="An Application representing the currently running application.">ApplicationSelf</a>() {
<a name="l00168"></a>00168         _preconstruct();
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170     <span class="keyword">virtual</span> ~<a class="code" href="class_sylph_1_1_application_self.html" title="An Application representing the currently running application.">ApplicationSelf</a>();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     <span class="keywordtype">void</span> _fail(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> appName, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> reason);
<a name="l00173"></a>00173     <span class="keywordtype">void</span> _fail(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> appName, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> reason,
<a name="l00174"></a>00174             <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> file, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="keyword">private</span>:
<a name="l00177"></a>00177     <span class="keywordtype">void</span> _preconstruct();
<a name="l00178"></a>00178     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> _appName;
<a name="l00179"></a>00179     <a class="code" href="namespace_sylph.html#8e3a8cf0fd1c1cf417e7834d2a473dc4" title="This enumeration contains the possible Application Types.">AppType</a> _appType;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 };
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 SYLPH_END_NAMESPACE
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="preprocessor">#endif  </span><span class="comment">/* APPLICATION_H_ */</span>
<a name="l00187"></a>00187 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
